#!/usr/bin/env python3.2

################################################################################ 

# Jiehan ZHENG,
# 北京四中研学之用.

# flag 将被放置于输出文件的第三列, 约定:
#    R - 被重置:    被 RESET 方法封锁.
#    P - 正常:    没有发现异常.


# 获取搜索结果参数设置:
ATTEMPT_FETCH_CHARS = None        # 只尝试读取内容的前(?)个字符, None 则不限
FETCH_PRINT_CHATS    = 100        # 输出返回内容的前(?)个字符

# 检测 RESET 状态测试关键词和间隔:
TEST_KEYWORD  = "bhsf"            # 在被 RESET 一次后, 每隔 TEST_INTERVAL 再搜索一次这
                                # 个关键词, 这个词应该是一个明显不会被屏蔽的
TEST_INTERVAL = 300                # RESET 状态检测间隔

################################################################################

import time
import sys
import urllib.request
import urllib.parse
import re

from progressbar import ProgressBar, Percentage, Bar

def test_by_google(keyword):
    # FIXME 假 User-Agent
    params = urllib.parse.urlencode({'q': keyword})
    headers = {'User-Agent': 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Ubuntu/11.04'}
    try:
        req = urllib.request.Request("http://www.google.com.hk/search?%s" % params, None, headers)
        result = urllib.request.urlopen(req, None, 5)
        content = result.read().decode('utf-8')
                
        # 检查返回搜索结果中是否包含我们搜索的关键词
        if re.search(keyword, content) == None:
            print("[!] 收到回应, 但 content 中未找到 \"%s\" % keyword")
            return False
        
        print("[~] 无误, content 中找到 \"%s\"" % keyword)
        return True
    except:
        # 发生了异常，代表我们被重置了
        print("[!] \"%s\" 被重置" % keyword)
        return False

def jiehan_wait(interval):
    pbar = ProgressBar(widgets=[Percentage(), Bar()], maxval=300).start()
    for i in range(300):
        time.sleep(interval / 300)
        pbar.update(i+1)
    pbar.finish()

def wait_until_unblock(wait=True):
    sys.stdout.write('[X] 清理: 解封测试:\n')
    
    if wait:
        jiehan_wait(TEST_INTERVAL)
    
    current_wait = 1
    
    sys.stdout.write('[重试 #%d]\n' % current_wait)
    sys.stdout.flush()
    
    while test_by_google(TEST_KEYWORD) == False:
        current_wait = current_wait + 1
        
        jiehan_wait(TEST_INTERVAL)
        sys.stdout.write('[RETRY #%d]\n' % current_wait)
        sys.stdout.flush()
    
    print("[~] 当前解封!\n")


def main():
    list_filename = sys.argv[1]
    
    list_file = open(list_filename)
    words = list_file.readlines()
    
    report_file = open('report-%s' % sys.argv[1], 'w')
    
    wait_until_unblock(wait=False)
    
    for line in words:
        # flags = ''
        wait = False
        
        # word, freq = line.rstrip().split('\t')
        word = line.rstrip()
        
        word_test = word
        
        print('>>> 正在测试 "%s": ' % word)

        if test_by_google(word_test) == True:
            flags = 'P'
            print('[~] PASS\n')
        else:
            flags = 'R'
            wait = True
            print('[!] FAIL...\n')
        
        # report_file.write('%s\t%s\t%s\n' % (word, freq, flags))
        report_file.write('%s\t%s\n' % (word, flags))
        
        if wait == True:
            wait_until_unblock()
        
        # XXX 放慢速度防止被 Google 查封
        #time.sleep(10)


if __name__ == '__main__':
    main()
